//
//	IMGDEF.H
//
//	Definitions for VAX/VMS image activations
//


struct IAF {
	long		offset_g_fix;
	long		offset_shl;
	long		offset_addr;
	long		offset_chgprot;
	long		offset_names;
	long		shrimgcnt;
};


struct SHR {
	struct SHR *	next;
	char			name[ 40 ];
	long			id;
	long			base;
};


struct IHD {
	short		size;
	short		offset_transfer;
	short		offset_dst;
	short		offset_ident;
	short		offset_patch;
	short		minor_id;
	short		major_id;
	char		header_blocks;
	char		image_type;
	long		mask[ 2 ];
	short		channels;
	short		io_pages;
	long		flags;
	long		section_id;
	long		version;
};

struct IHI {
	char		imgnaml;
	char		imgnam[ 39 ];
	char		imgidl;
	char		imgid[ 15 ];
	long		time[ 2 ];
	char		linkidl;
	char		linkid[ 15 ];
};

#define IHI_SIZE 80

struct ISD { 
	struct ISD *next;
	short		size;
	short		pages;
	short		vpn;
	short		pfc;
	long		flags;
	long		vbn;
	long		section_id;
	char		count;
	char		name[ 15 ];
};

/*
 *	Values for the ISD flags field.
 */
 
#define ISD_V_GBL	0
#define ISD_V_CRF	1
#define ISD_V_DZRO	2
#define ISD_V_WRT	3
#define ISD_V_LASTCLU	7
#define ISD_V_COPYALWAY	8
#define ISD_V_BASED	9
#define ISD_V_FIXUPVEC	10
#define ISD_V_VECTOR	17
#define ISD_V_PROTECT	18

#define ISD_M_GBL	(1<<ISD_V_GBL)
#define ISD_M_CRF	(1<<ISD_V_CRF)
#define ISD_M_DZRO	(1<<ISD_V_DZRO)
#define ISD_M_WRT	(1<<ISD_V_WRT)
#define ISD_M_LASTCLU	(1<<ISD_V_LASTCLU)
#define ISD_M_COPYALWAY	(1<<ISD_V_COPYALWAY)
#define ISD_M_BASED	(1<<ISD_V_BASED)
#define ISD_M_FIXUPVEC	(1<<ISD_V_FIXUPVEC)
#define ISD_M_PROTECT	(1<<ISD_V_PROTECT)

/*
 *	Type field is high byte of flags field
 */
#define ISD_V_TYPE	24
#define ISD_M_TYPE	(0xff<<ISD_V_TYPE)
#define ISD_B_TYPE( isd_l_flags )	(((isd_l_flags)&ISD_M_TYPE)>>ISD_V_TYPE)

#define ISD_K_NORMAL	0
#define ISD_K_SHRFXD	1
#define ISD_K_PRVFXD	2
#define ISD_K_SHRPIC	3
#define ISD_K_PRVPIC	4
#define ISD_K_USRSTACK	253
